<template>
  <div>
    <div class="add-aseet-top">
      <v-form @submit.prevent="submitForm">
        <v-text-field
          label="Please Input Asset Number"
          hide-details="auto"
          v-model="inputAssetNumber"
        ></v-text-field>
      </v-form>
      <div class="asset-result-message">
        <div v-if="assetAddResult === true">
          <v-alert dense text type="success" class="mt-5">
            {{ successMessage }}
          </v-alert>
        </div>
        <div v-if="assetAddResult === false">
          <v-alert dense text type="error" class="mt-5">
            {{ errorMessage }}
          </v-alert>
        </div>
      </div>
    </div>
    <div class="mt-10 mx-5">
      <v-form>
        <v-text-field
          label="자산번호"
          v-model="asset.number"
          filled
          dense
          readonly
        ></v-text-field>
        <v-text-field
          label="자산명"
          v-model="asset.name"
          filled
          dense
          readonly
        ></v-text-field>
        <v-text-field
          label="확인 시간"
          v-model="asset.check_time"
          filled
          dense
          readonly
        ></v-text-field>
        <v-text-field
          label="확인 횟수"
          v-model="asset.count"
          filled
          dense
          readonly
        ></v-text-field>
        <v-text-field
          v-model="asset.where"
          label="보관장소"
          clearable
        ></v-text-field>
        <v-text-field
          v-model="asset.comment"
          label="특이사항"
          clearable
        ></v-text-field>
        <v-btn
          :disabled="asset.number == null"
          color="success"
          class="mr-4"
          @click="update"
        >
          Update
        </v-btn>
        <v-btn color="warning" @click="clear"> Clear </v-btn>
      </v-form>
    </div>
  </div>
</template>

<script>
import { addAssetData, updateAssetData } from "../api/index";

export default {
  data() {
    return {
      inputAssetNumber: null,
      asset: {
        number: null,
        name: null,
        where: null,
        check_time: null,
        count: null,
        comment: null
      },
      assetAddResult: null,
      successMessage: "등록된 자산입니다. 자산 정보를 업데이트 합니다.",
      errorMessage: "등록되지 않은 자산입니다.",
      valid: null
    };
  },
  methods: {
    submitForm() {
      const json = { asset_number: this.inputAssetNumber };
      addAssetData(json).then(({ data }) => {
        this.assetAddResult = data.result === "success" ? true : false;
        if (this.assetAddResult) {
          this.asset.number = this.inputAssetNumber;
          this.asset.name = data.asset_name;
          this.asset.where = data.asset_where;
          this.asset.check_time = data.asset_check_time;
          this.asset.count = data.asset_count;
          this.asset.comment = data.asset_comment;
          this.$store.dispatch("GET_TOTAL_ASSET_DATA");
        }
        this.inputAssetNumber = null;
      });
    },
    update() {
      console.log("validate");
      const json = {
        asset_number: this.asset.number,
        asset_where: this.asset.where,
        asset_comment: this.asset.comment
      };
      updateAssetData(json).then(() => {
        this.$store.dispatch("GET_TOTAL_ASSET_DATA");
      });
    },
    clear() {
      this.asset.number = null;
      this.asset.name = null;
      this.asset.where = null;
      this.asset.check_time = null;
      this.asset.count = null;
      this.asset.comment = null;
    }
  }
};
</script>
